from turtle import pd
from binance import Client
import telebot
import pandas as pd
from telebot import types
import time
import emoji
from config import api_key, api_secret, api_tele


bot = telebot.TeleBot(api_tele)
client = Client(api_key, api_secret)

posframe = pd.read_csv('position.txt')


def changepos(curr, buy=True):
    if buy:
        posframe.loc[posframe.Currency == curr, 'position'] = 1

    else:
        posframe.loc[posframe.Currency == curr, 'position'] = 0

    posframe.to_csv('position', index=False)

def gethourlydata(symbol):
    frame = pd.DataFrame(client.get_historical_klines(symbol, '1h', '25 hours ago UTC'))
    frame = frame.iloc[:, :5]
    frame.columns = ['Time', 'Open', 'High', 'Low', 'Close']
    frame[['Open', 'High', 'Low', 'Close']] = frame[['Open', 'High', 'Low', 'Close']].astype(float)
    frame.Time = pd.to_datetime(frame.Time, unit='ms')
    return frame

df = gethourlydata('ADAUSDT')

def applytechnicals(df):
    df['FastSMA'] = df.Close.rolling(7).mean()
    df['SlowSMA'] = df.Close.rolling(25).mean()

applytechnicals(df)

def trader(curr, chat_id):
    qty = posframe[posframe.Currency == curr].quantity.values[0]
    act_before = posframe[posframe.Currency == curr].action.values[0]
    tag = posframe[posframe.Currency == curr].tag.values[0]
    df = gethourlydata(curr)
    applytechnicals(df)
    lastrow = df.iloc[-1]
    if not posframe[posframe.Currency == curr].position.values[0]:
        if lastrow.FastSMA > lastrow.SlowSMA and act_before == 0:
            try:

                dev_up = round((lastrow.FastSMA / lastrow.SlowSMA - 1) * 100, 2)
                price = round(lastrow.FastSMA, 4)
                posframe.loc[posframe.Currency == curr, 'dev'] = dev_up
                posframe.to_csv('position.txt', index=False)
                if dev_up < 0.1:
                    msg = emoji.emojize(":hourglass_not_done:") + f'Wait more 0.1%  #{tag}| {dev_up}%\nAverage price for the last hour: {curr} - {price}'
                    bot.send_message(chat_id, msg)
                    print(f'Wait more 0.1% {curr} | {dev_up}% | price: {price}')
                else:
                    msg = emoji.emojize(":heavy_dollar_sign:") + f'#{tag}| {dev_up}% increasing | BUY\nAverage price for the last hour: {curr} - {price}'
                    bot.send_message(chat_id, msg)

            except:
                 msg = emoji.emojize(":angry_face:") + f'DO NOT BUY {curr}. \nCHECK BALANCE'
                 bot.send_message(chat_id, msg)

        else:
            dev_down = round((lastrow.FastSMA / lastrow.SlowSMA - 1) * 100, 2)
            price = round(lastrow.FastSMA, 4)
            posframe.loc[posframe.Currency == curr, 'dev'] = dev_down
            posframe.to_csv('position.txt', index=False)
            msg = emoji.emojize(":alarm_clock:") + f'Wait for BUY #{tag} | {dev_down}%\nAverage price for the last hour: {curr} - {price}'
            bot.send_message(chat_id, msg)
            print(f'Wait for BUY {curr} | {dev_down}% | price: {price}')

    elif posframe[posframe.Currency == curr].position.values[0] == 2:
        dev_down = round((lastrow.FastSMA / lastrow.SlowSMA - 1) * 100, 2)
        posframe.loc[posframe.Currency == curr, 'dev'] = dev_down
        posframe.to_csv('position.txt', index=False)
        price = round(lastrow.FastSMA, 4)
        if dev_down >= 0:
            msg = emoji.emojize(":alarm_clock:") + f'Wait for minus position #{tag} | {dev_down}%\nAverage price for the last hour: {curr} - {price}'
            bot.send_message(chat_id, msg)
            print(f'Wait for minus position {curr} | {dev_down}% | price: {price}')

        else:
            changepos(curr, buy=False)
            dev_down = round((lastrow.FastSMA / lastrow.SlowSMA - 1) * 100, 2)
            price = round(lastrow.FastSMA, 4)
            posframe.loc[posframe.Currency == curr, 'dev'] = dev_down
            posframe.to_csv('position.txt', index=False)
            msg = emoji.emojize(":alarm_clock:") + f'Wait for BUY #{tag} | {dev_down}%\nAverage price for the last hour: {curr} - {price}'
            bot.send_message(chat_id, msg)
            print(f'Wait for BUY {curr} | {dev_down}% | price: {price}')

    else:
        if lastrow.FastSMA < lastrow.SlowSMA:
            try:
                dev_down = round((lastrow.FastSMA / lastrow.SlowSMA - 1) * 100, 2)
                price = round(lastrow.FastSMA, 4)
                posframe.loc[posframe.Currency == curr, 'dev'] = dev_down
                posframe.to_csv('position.txt', index=False)
                msg = emoji.emojize(":no_entry:") + f'SELL #{tag} | Increasing {dev_down}%\nAverage price for the last hour: {curr} - {price}'
                bot.send_message(chat_id, msg)
                posframe.loc[posframe.Currency == curr, 'action'] = 0
                posframe.to_csv('position.txt', index=False)
                changepos(curr, buy=False)
            except Exception:
                msg = emoji.emojize(":angry_face:") + f'DO NOT SELL {curr}.\nCHECK BALANCE'
                bot.send_message(chat_id, msg)

        else:
            act_before = posframe[posframe.Currency == curr].action.values[0]
            dev_before = posframe[posframe.Currency == curr].dev.values[0]
            dev_down = round((lastrow.FastSMA / lastrow.SlowSMA - 1) * 100, 2)
            price = round(lastrow.FastSMA, 4)
            if lastrow.FastSMA > lastrow.SlowSMA and act_before <= 3:
                if dev_down > dev_before:
                    msg = emoji.emojize(":chart_increasing:") + f'#{tag} | Increasing  {dev_down}%\nAverage price for the last hour: {curr} - {price}'
                    bot.send_message(chat_id, msg)
                    posframe.loc[posframe.Currency == curr, 'dev'] = dev_down
                    posframe.loc[posframe.Currency == curr, 'action'] = 0
                    posframe.to_csv('position.txt', index=False)
                else:
                    posframe.loc[posframe.Currency == curr, 'dev'] = dev_down
                    posframe.loc[posframe.Currency == curr, 'action'] += 1
                    posframe.to_csv('position.txt', index=False)
                    msg = emoji.emojize(":chart_decreasing:") + f'#{tag} | Decreasing {dev_down}%\nAverage price for the last hour: {curr} - {price}'
                    bot.send_message(chat_id, msg)

            else:
                changepos(curr, buy=False)
                posframe.loc[posframe.Currency == curr, 'action'] = 0
                posframe.loc[posframe.Currency == curr, 'position'] = 2
                posframe.to_csv('position.txt', index=False)
                msg = emoji.emojize(":no_entry:") + f'SELL #{tag} | Increasing {dev_down}%\nAverage price for the last hour: {curr} - {price}'
                bot.send_message(chat_id, msg)


@bot.message_handler(commands=["start"])
def start(message, res=False):

    markup = types.ReplyKeyboardMarkup(resize_keyboard=True)
    btn_strategy = types.KeyboardButton("COMMANDS")
    markup.add(btn_strategy)
    msg = emoji.emojize(":man:") + 'HI!\nI am Bot. I am ready to help earn money for you.'
    bot.send_message(message.chat.id, msg, reply_markup=markup)

@bot.message_handler(content_types=["text"])
def handle_text(message):
    if message.text.strip() == 'COMMANDS':
        keyboard = types.InlineKeyboardMarkup()
        btn_start = types.InlineKeyboardButton(text='START', callback_data='cycle_start')

        keyboard.add(btn_start)
        msg = emoji.emojize(":rocket:") + 'Press START'
        bot.send_message(message.chat.id, msg, reply_markup=keyboard)

@bot.callback_query_handler(func=lambda call: call.data.startswith('cycle_start'))
def callback_worker_promo(call):
    msg = emoji.emojize(":popcorn:") + 'Good luck!'
    bot.send_message(call.message.chat.id, msg)
    chat_id = call.message.chat.id

    while True:

        posframe = pd.read_csv('position.txt')
        for coin in posframe.Currency:
            trader(coin, chat_id)

        else:
            pass

        time.sleep(1800)

@bot.callback_query_handler(func=lambda call: call.data.startswith('cycle_stop'))
def callback_worker_stop(call):

    bot.send_message(call.message.chat.id, 'Under construction')

@bot.callback_query_handler(func=lambda call: call.data.startswith('cycle_info'))
def callback_worker_info(call):
    msg = 'Under construction'
    bot.answer_callback_query(callback_query_id=call.id, text=msg, show_alert=True)

@bot.callback_query_handler(func=lambda call: call.data.startswith('cycle_check'))
def callback_worker_check(call):
    msg = emoji.emojize(":thumbs_up:") + 'I am here'
    bot.send_message(call.message.chat.id, msg)

bot.polling(none_stop=True)


